
;
        Appl    " 5 Effects",'EF11'
        include "Pilot.inc"
        include "Startup.inc"

; Equates 

form1   equ     1000
pull1   equ     1001
alert1  equ     1000

; Data Area 

        data

screenadr  dc.l  0
pictureadr dc.l  0
pz      dc.l    0
zz1     dc.l    0
step1w  dc.l    0
step2w  dc.l    0
step3w  dc.l    0
global  speich.3220             ;internal Mem for pictureadr ((160*160/8)+20

; Circle Data 

radius  dc.w    78              ;Radius for circle routine
xg      dc.w    157             ;X-Boundary
yg      dc.w    157             ;Y-Boundary
px      dc.w    0               ;X-Position
py      dc.w    0               ;Y-Position
xm      dc.w    80              ;X-Center
ym      dc.w    80              ;Y-Center

y1      dc.w    0
y2      dc.w    0
x1      dc.w    0
x2      dc.w    0

; Text Area 

text1   dc.b    'T.J. Graphic-Effects'
text    dc.b    '  Tap on the Screen '

; Global Area 

global  formptr.l                               ;<-Form Pointer

; Assembly Source-Code-Area 

        code

        include "pilotmai.mac"
        include "kreis.mac"
        include "beam.mac"
        include "klap.mac"
        include "folk.mac"

;

proc    ApplicationHandleEvent(pevt.l)

beginproc
        movem.l a3,-(a7)
        movea.l pevt(a6),a0                             ; A0 = pevt

        cmp.w   #frmLoadEvent,EventType.eType(a0)       ; frmLoadEvent ?
        bne.s   AHENotHandled

; Form init 

        systrap FrmInitForm(EventType.data+frmLoad.formID(a0).w)
        move.l  a0,a3
        move.l  a0,formptr(a5)
        systrap FrmSetActiveForm(a0.l)

;
AHEHandled
        moveq.l #1,d0
        bra.s   AHEReturn
AHENotHandled
        moveq.l #0,d0
AHEReturn
        movem.l (a7)+,a3
endproc

;

proc    MainFormHandleEvent(pevt.l)
beginproc
        movea.l pevt(a6),a0
        move.w  EventType.eType(a0),d0

; Form open 

        cmp.w   #frmOpenEvent,d0                        ; Form Open Event
        bne.s   MFH1
        systrap FrmGetActiveForm()                      ; Draw the Form
        systrap FrmDrawForm(a0.l)
        move.l  formptr(a5),a0
        move.l  4(a0),screenadr(a5)
        bra.s   MFHHandled

; Events 

MFH1    cmp.w   #menuEvent,d0                           ; Menu Event ?
        beq.s   MenuHandler
        cmp.w   #penUpEvent,d0                          ; Pen Up Event ?
        beq.s   PenUpHandler
        bra.s   MFHNotHandled

; Handler 

MenuHandler                                             ; PULLDOWN
        move.w  EventType.data+menu.itemID(a0),d0
        cmp.w   #pull1,d0
        bne.s   MFHNotHandled
        systrap FrmAlert(#alert1.w)
        bra.s   MFHHandled

;

PenUpHandler                                            ;TAP
        move.w  EventType.screenX(a0),d0
        move.w  EventType.screenY(a0),d1

        movem.l d0-d7/a0-a6,-(a7)
        call    getbitmap()                             ;Make Animation
        movem.l (a7)+,d0-d7/a0-a6

        bra     MFHHandled

;
MFHHandled
        moveq.l #1,d0
        bra.s   MFHReturn
MFHNotHandled
        moveq.l #0,d0
MFHReturn
endproc

;

proc    drawbitmap()                                    ;Draw a picture
beginproc                                               ;on the screen
	movem.l	a3,-(a7)
        move.l  #'Tbmp',d0
        systrap DmGetResource(d0.l,d6.w)
	cmp.l	#0,a0
        beq.s   DError
	move.l	a0,a3
	systrap MemHandleLock(a0.l)
	cmp.l	#0,a0
        beq.s   DError
        systrap WinDrawBitmap(a0.l,d5.w,#0.w)
	systrap MemHandleUnlock(a3.l)		
	systrap DmReleaseResource(a3.l)
DError
	movem.l	(a7)+,a3
endproc

;

proc    getbitmap()
beginproc
        move.l  #2000,d6                        ;BMP ID
        move.l  #10,d5                          ;X-Pos of pictureadr on screen
        call    drawbitmap()                    ;draw the picture on screen

        lea.l   speich(a5),a4
        move.l  a4,pictureadr(a5)

        move.l  screenadr(a5),a0

        move.l  #800-1,d0                       ;copy pic from screen to speich
jur     move.l  (a0)+,(a4)+
        dbf     d0,jur

        call    klapdown()                      ;animate now

        move.w  #0,radius(a5)
        move.w  #110,d6

frtw    movem.l d0-d7/a0-a6,-(a7)                ;circle the picture
        move.w  #81,xm(a5)
        move.w  #79,ym(a5)
        call    circle()
        move.w  #80,xm(a5)
        move.w  #80,ym(a5)
        call    circle()
        move.w  #81,xm(a5)
        move.w  #81,ym(a5)
        call    circle()
        movem.l (a7)+,d0-d7/a0-a6
        add.w   #1,radius(a5)

        dbf     d6,frtw
gxx
        call    beam()
        call    klapdown()
        call    folk()

        lea.l   text(a5),a0
        systrap WinDrawChars(a0.l,#20.w,#39.w,#150.w)    ;PTR LEN X Y
        lea.l   text1(a5),a0
        systrap WinDrawChars(a0.l,#20.w,#39.w,#140.w)    ;PTR LEN X Y
endproc
;
proc    cls()                                           ;clear the Form
beginproc
        systrap WinEraseWindow()
        systrap FrmGetActiveForm()
        systrap FrmDrawForm(a0.l)
endproc
;
        res     'WBMP',$7ffe,"diamand.bmp"
        res     'WBMP',2000,"tom.bmp"
        res     'pref', 1
        dc.w    sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
        dc.l    $1000                           ; stack size
        dc.l    $1000                           ; heap size
        res     'Talt',1000,"talt03e8.bin"
        res     'tFRM',1000,"tfrm03e8.bin"
        res     'MBAR',1000,"mbar03e8.bin"
        res     'tver', 1
        dc.b    '1.1', 0
;

